#include "enet/enet.h"

#define SERVER_PORT 60000

class Client{

    public:
        ENetHost * client;
        ENetAddress address;
        ENetEvent event;
        ENetPeer *peer;
        bool connected;
        int whoisclient;
        int hasHit;

        char indirizzo[256];

        float p1x;
        float p1y;
        float p1z;
        float r1x;
        float r1y;
        float r1z;

        float p2x;
        float p2y;
        float p2z;
        float r2x;
        float r2y;
        float r2z;


        float p3x;
        float p3y;
        float p3z;
        float r3x;
        float r3y;
        float r3z;


    void initFields(){

        hasHit = 0;

        p1x = 1404;
        p1y = 94;
        p1z = 1346;

        r1x = 0;
        r1y = 0;
        r1z = 0;

        p2x = 1404;
        p2y = 94;
        p2z = 1316;

        r2x = 0;
        r2y = 0;
        r2z = 0;

        p3x = 1404;
        p3y = 94;
        p3z = 1376;

        r3x = 0;
        r3y = 0;
        r3z = 0;

    }


    Client(){

        initFields();

        connected = false;

        client = enet_host_create (NULL /* create a client host */,
                1 /* only allow 1 outgoing connection */,
                0,
                0);
        if (client == NULL)
        {
            fprintf (stderr,
                     "An error occurred while trying to create an ENet client host.\n");
            exit (EXIT_FAILURE);
        }

    }

    void sendShock(){

        printf("sending shock!\n");

        char coX[15];
        sprintf(coX,"SHOCK");
        ENetPacket * packetX = enet_packet_create (coX,
                                          strlen (coX) + 1,
                                          ENET_PACKET_FLAG_RELIABLE);
        enet_peer_send (peer, 0, packetX);

        enet_host_flush (client);

    }

    void updCoords(){

    //printf("client updating coordinates\n\n");

        if ( whoisclient == 2 ){
            //invia le proprie coords al server
            char coX[15];
            sprintf(coX,"2x=%11.4f",p2x);
            ENetPacket * packetX = enet_packet_create (coX,
                                              strlen (coX) + 1,
                                              ENET_PACKET_FLAG_RELIABLE);
            enet_peer_send (peer, 0, packetX);

            char coY[15];
            sprintf(coY,"2y=%11.4f",p2y);
            ENetPacket * packetY = enet_packet_create (coY,
                                              strlen (coY) + 1,
                                              ENET_PACKET_FLAG_RELIABLE);
            enet_peer_send (peer, 0, packetY);

            char coZ[15];
            sprintf(coZ,"2z=%11.4f",p2z);
            ENetPacket * packetZ = enet_packet_create (coZ,
                                              strlen (coZ) + 1,
                                              ENET_PACKET_FLAG_RELIABLE);
            enet_peer_send (peer, 0, packetZ);




            char corX[16];
            sprintf(corX,"2rx=%11.4f",r2x);
            ENetPacket * packetrX = enet_packet_create (corX,
                                              strlen (corX) + 1,
                                              ENET_PACKET_FLAG_RELIABLE);
            enet_peer_send (peer, 0, packetrX);

            char corY[16];
            sprintf(corY,"2ry=%11.4f",r2y);
            ENetPacket * packetrY = enet_packet_create (corY,
                                              strlen (corY) + 1,
                                              ENET_PACKET_FLAG_RELIABLE);
            enet_peer_send (peer, 0, packetrY);

            char corZ[16];
            sprintf(corZ,"2rz=%11.4f",r2z);
            ENetPacket * packetrZ = enet_packet_create (corZ,
                                              strlen (corZ) + 1,
                                              ENET_PACKET_FLAG_RELIABLE);
            enet_peer_send (peer, 0, packetrZ);



            // prende le altre 2 coords dal server

        } else if ( whoisclient == 3 ){

            //invia le proprie coords al server
            char coX[15];
            sprintf(coX,"3x=%11.4f",p3x);
            ENetPacket * packetX = enet_packet_create (coX,
                                              strlen (coX) + 1,
                                              ENET_PACKET_FLAG_RELIABLE);
            enet_peer_send (peer, 0, packetX);

            char coY[15];
            sprintf(coY,"3y=%11.4f",p3y);
            ENetPacket * packetY = enet_packet_create (coY,
                                              strlen (coY) + 1,
                                              ENET_PACKET_FLAG_RELIABLE);
            enet_peer_send (peer, 0, packetY);

            char coZ[15];
            sprintf(coZ,"3z=%11.4f",p3z);
            ENetPacket * packetZ = enet_packet_create (coZ,
                                              strlen (coZ) + 1,
                                              ENET_PACKET_FLAG_RELIABLE);
            enet_peer_send (peer, 0, packetZ);




            char corX[16];
            sprintf(corX,"3rx=%11.4f",r3x);
            ENetPacket * packetrX = enet_packet_create (corX,
                                              strlen (corX) + 1,
                                              ENET_PACKET_FLAG_RELIABLE);
            enet_peer_send (peer, 0, packetrX);

            char corY[16];
            sprintf(corY,"3ry=%11.4f",r3y);
            ENetPacket * packetrY = enet_packet_create (corY,
                                              strlen (corY) + 1,
                                              ENET_PACKET_FLAG_RELIABLE);
            enet_peer_send (peer, 0, packetrY);

            char corZ[16];
            sprintf(corZ,"3rz=%11.4f",r3z);
            ENetPacket * packetrZ = enet_packet_create (corZ,
                                              strlen (corZ) + 1,
                                              ENET_PACKET_FLAG_RELIABLE);
            enet_peer_send (peer, 0, packetrZ);



            // prende le altre 2 coords dal server

        }

         enet_host_flush (client);

    }

    void connect(){

        printf("connecting to %s \n",indirizzo);
        enet_address_set_host (& address, indirizzo);
        address.port = 60000;
        peer = enet_host_connect (client, & address, 2);


        if (peer == NULL)
        {
           fprintf (stderr,
                    "No available peers for initiating an ENet connection.\n");
           exit (EXIT_FAILURE);
        }


        if (enet_host_service (client, & event, 5000) > 0 && event.type == ENET_EVENT_TYPE_CONNECT)
        {
            puts ("Connection to some.server.net:1234 succeeded.");
            connected = true;

        }
        else
        {
            /* Either the 5 seconds are up or a disconnect event was */
            /* received. Reset the peer in the event the 5 seconds   */
            /* had run out without any significant event.            */
            enet_peer_reset (peer);
            connected = false;

            puts ("Connection to some.server.net:1234 failed.");
        }



    }






    void handle(enet_uint8 * 	data , size_t l , ENetPeer * 	peer ){

l--;

        char recv[l+1];
        char dest[l+1];
        sprintf(recv,"%s",data);


        if( strstr(  recv,"1x=")  && whoisclient!=1 ){
            sprintf(dest,"%.*s\n", l - 3, &recv[3]);
            p1x = atof( dest );
        } else if( strstr(  recv,"1y=")   && whoisclient!=1 ){
            strncpy(dest, recv + 3, l - 3 + 1)[l - 3] = 0;
            p1y = atof( dest  );
        } else if( strstr(  recv,"1z=")   && whoisclient!=1 ){
            strncpy(dest, recv + 3, l - 3 + 1)[l - 3] = 0;
            p1z = atof( dest  );
        } else if( strstr(  recv,"1rx=")   && whoisclient!=1 ){
            strncpy(dest, recv + 4, l - 4 + 1)[l - 4] = 0;
            r1x = atof( dest  );
        } else if( strstr(  recv,"1ry=")   && whoisclient!=1 ){
            strncpy(dest, recv + 4, l - 4 + 1)[l - 4] = 0;
            r1y = atof( dest  );
        } else if( strstr(  recv,"1rz=")   && whoisclient!=1 ){
            strncpy(dest, recv + 4, l - 4 + 1)[l - 4] = 0;
            r1z = atof( dest  );
        } else if( strstr(  recv,"2x=")   && whoisclient!=2 ){
            sprintf(dest,"%.*s\n", l - 3, &recv[3]);
            p2x = atof( dest );
        } else if( strstr(  recv,"2y=")  && whoisclient!=2){
            strncpy(dest, recv + 3, l - 3 + 1)[l - 3] = 0;
            p2y = atof( dest  );
        } else if( strstr(  recv,"2z=")  && whoisclient!=2){
            strncpy(dest, recv + 3, l - 3 + 1)[l - 3] = 0;
            p2z = atof( dest  );
        } else if( strstr(  recv,"2rx=")  && whoisclient!=2){
            strncpy(dest, recv + 4, l - 4 + 1)[l - 4] = 0;
            r2x = atof( dest  );
        } else if( strstr(  recv,"2ry=")  && whoisclient!=2){
            strncpy(dest, recv + 4, l - 4 + 1)[l - 4] = 0;
            r2y = atof( dest  );
        } else if( strstr(  recv,"2rz=")  && whoisclient!=2){
            strncpy(dest, recv + 4, l - 4 + 1)[l - 4] = 0;
            r2z = atof( dest  );
        } else if( strstr(  recv,"3x=")  && whoisclient!=3){
            strncpy(dest, recv + 3, l - 3 + 1)[l - 3] = 0;
            p3x = atof( dest  );
        } else if( strstr(  recv,"3y=")  && whoisclient!=3){
            strncpy(dest, recv + 3, l - 3 + 1)[l - 3] = 0;
            p3y = atof( dest  );
        } else if( strstr(  recv,"3z=") && whoisclient!=3){
            strncpy(dest, recv + 3, l - 3 + 1)[l - 3] = 0;
            p3z = atof( dest  );
        } else if( strstr(  recv,"3rx=") && whoisclient!=3){
            strncpy(dest, recv + 4, l - 4 + 1)[l - 4] = 0;
            r3x = atof( dest  );
        } else if( strstr(  recv,"3ry=") && whoisclient!=3){
            strncpy(dest, recv + 4, l - 4 + 1)[l - 4] = 0;
            r3y = atof( dest  );
        } else if( strstr(  recv,"3rz=") && whoisclient!=3){
            strncpy(dest, recv + 4, l - 4 + 1)[l - 4] = 0;
            r3z = atof( dest  );
        }
    }







    void procEv(){

        ENetEvent event;

        /* Wait up to 1000 milliseconds for an event. */
        while (enet_host_service (client, & event, 0) > 0)
        {
            switch (event.type)
            {
            case ENET_EVENT_TYPE_CONNECT:
                printf ("A new client connected from %x:%u.\n",
                        event.peer -> address.host,
                        event.peer -> address.port);

                /* Store any relevant client information here. */
                //event.peer -> data = "Client information";

                break;

            case ENET_EVENT_TYPE_RECEIVE:
                //printf ("A packet of length %u containing %s was received from %s on channel %u.\n",
                //        event.packet -> dataLength,
                //        event.packet -> data,
                //        event.peer -> data,
                //        event.channelID);

                handle(event.packet -> data,event.packet -> dataLength, event.peer);
                /* Clean up the packet now that we're done using it. */
                enet_packet_destroy (event.packet);

                break;

            case ENET_EVENT_TYPE_DISCONNECT:
                printf ("CLIENT: server %s disconected.\n", event.peer -> data);

                connected = false;

                enet_host_destroy(client);

                client = enet_host_create (NULL /* create a client host */,
                        1 /* only allow 1 outgoing connection */,
                        0,
                        0);
                if (client == NULL)
                {
                    fprintf (stderr,
                             "An error occurred while trying to create an ENet client host.\n");
                    exit (EXIT_FAILURE);
                }

                connect();

                /* Reset the peer's client information. */

                event.peer -> data = NULL;
            }
        }
    }

    virtual ~Client(){
        enet_host_destroy(client);
    }

};
