#include <cstdlib>
#include <irrlicht.h>
#include "fmod.h"
#include "enet/enet.h"
#include "server.h"
#include "client.h"

using namespace irr;

#ifdef _IRR_WINDOWS_
#pragma comment(lib, "Irrlicht.lib")
#endif

class MyEventReceiver : public IEventReceiver
{
public:
        // This is the one method that we have to implement
        virtual bool OnEvent(const SEvent& event)
        {
                // Remember whether each key is down or up
                if (event.EventType == irr::EET_KEY_INPUT_EVENT){
                        //printf("tasto schiacciato\n");
                        KeyIsDown[event.KeyInput.Key] = event.KeyInput.PressedDown;
                }

                return false;
        }

        // This is used to check whether a key is being held down
        virtual bool IsKeyDown(EKEY_CODE keyCode) const
        {
                return KeyIsDown[keyCode];
        }

        MyEventReceiver()
        {
                for (u32 i=0; i<KEY_KEY_CODES_COUNT; ++i)
                        KeyIsDown[i] = false;
        }

private:
        // We use this array to store the current state of each key
        bool KeyIsDown[KEY_KEY_CODES_COUNT];
};





void setup(scene::ISceneManager* smgr,IrrlichtDevice *device,video::IVideoDriver* driver);
void loop(scene::ISceneManager* smgr, IrrlichtDevice *device,video::IVideoDriver* driver);


MyEventReceiver receiver;

IrrlichtDevice *device;
scene::ICameraSceneNode* camera ;
scene::ITriangleSelector* selector ;
scene::IBillboardSceneNode * bill;
video::SMaterial material;
video::SMaterial materialWhite;
scene::ISceneNode* q3node;
scene::IAnimatedMeshSceneNode* node1;
scene::IAnimatedMeshSceneNode* node2;
scene::IAnimatedMeshSceneNode* node3;

int whoami;


//FSOUND_STREAM *bkgSoundLounge;




Client *client;
Server *server;


int ct;
